;
; slrom menu 128k/256k PRG + 128k CHR
;

.include "dduck-charmap.asm"; кодировка шрифта
ARROW_SIGN = '-' ; символ стрелки
NBANK_FONT = 27 ; номер банка chr(блок 16*16 символов) со шрифтом 0-31
RESET_OLD = $ffe0 ; старое значение вектора сброса $fffc-$fffd

;OFFSET_PRESET =  ; смещение на неиспользуемое пространство в последнем банке (для переключения)
OFFSET_MENU = $1f06f-16 ; смещение на неиспользуемое пространство для кода меню
OFFSET_MENU2 = $1fc5c-16 ; смещение на второе неиспользуемое пространство


.linecont on ; разрыв строки по \
.feature c_comments; разрешение /* комментарий */

.include "nesdefs.inc"

JOYPAD1 = $4016
MMC1_CTRL = $8000
MMC1_CHR0 = $a000
MMC1_CHR1 = $c000
MMC1_PRG  = $e000

; заголовок
.segment "INESHDR"
    INES_MAPPER = 1 ; 0 = NROM, 2 = UNROM, 1 = MMC1(AX5904)
    INES_MIRROR = 0 ; 0 = horizontal mirroring, 1 = vertical mirroring
    INES_SRAM   = 0 ; 1 = battery backed SRAM at $6000-7FFF
    .byt $4E, $45, $53, $1A ; 'NES' ID
    .byt 2 ; 16k PRG bank count
    .byt 16 ; 8k CHR bank count
    .byt INES_MIRROR | (INES_SRAM << 1) | ((INES_MAPPER & $f) << 4)
    .byt (INES_MAPPER & %11110000)


.ifdef OFFSET_PRESET
    ORG_PRESET = $8000 + $4000 + (OFFSET_PRESET) .mod $4000
    .assert ((OFFSET_PRESET / $4000 = 7) .OR \
        (OFFSET_PRESET / $4000 = 15)), error , "OFFSET_PRESET не в последнем банке"
    ORG_MENU = $8000 + OFFSET_MENU .mod $4000
    NBANK_PRG = OFFSET_MENU / $4000
    .out .sprintf ("Номер банка для кода = %d", NBANK_PRG)
    .out .sprintf ("Номер последнего банка = %d", OFFSET_PRESET / $4000 )
    .out .sprintf ("Новый вектор сброса = $%X (%02X %02X)", ORG_PRESET, ORG_PRESET .mod $100, ORG_PRESET / $100)

.elseif .defined(OFFSET_MENU)
    ORG_MENU = $8000 + $4000 + (OFFSET_MENU) .mod $4000
    .assert ((OFFSET_MENU / $4000 = 7) .OR \
        (OFFSET_MENU / $4000 = 15)), error , "OFFSET_MENU не в последнем банке"
    .out .sprintf ("Номер последнего банка = %d", OFFSET_MENU / $4000 )
    .out .sprintf ("Новый вектор сброса = $%X (%02X %02X)", ORG_MENU, ORG_MENU .mod $100, ORG_MENU / $100)
.endif


.ifdef OFFSET_MENU2
    .ifndef OFFSET_PRESET
        OFFSET_PRESET = -1 ; (.defined() .AND ...) не работает как ожидается
    .endif
    .if (OFFSET_PRESET / $4000 = OFFSET_MENU2 / $4000 ) ; OFFSET_MENU2 вместе с OFFSET_PRESET
        ORG_MENU2 = $8000 + $4000 + OFFSET_MENU2 .mod $4000
    .elseif (OFFSET_MENU / $4000 = OFFSET_MENU2 / $4000 ) ; OFFSET_MENU2 вместе с OFFSET_MENU
        ORG_MENU2 = (ORG_MENU / $4000) * $4000 + OFFSET_MENU2 .mod $4000
    .else
        .error "OFFSET_MENU2 в неправильном банке"
    .endif
.endif

; векторы прерываний
.segment "VECTORS"
	.addr nmi_isr, reset, irq_isr

; переменные
.segment "ZEROPAGE"
joy1:           .res 1 ; состояние джойстика
joy1prv:        .res 1 ; предыдущее состояние
codehere:       .res 1 ; начало кода лаунчера


; код
.segment "CODE"

nmi_isr:; прерывание nmi
irq_isr:; прерывание irq
	rti

.ifdef ORG_PRESET
    .byt $50, $52, $45, $53, $45, $54 ; "PRESET"
    .org ORG_PRESET ; код переключения
    sei
:   inc :-

    lda #NBANK_PRG
    sta MMC1_PRG
    lsr a
    sta MMC1_PRG
    lsr a
    sta MMC1_PRG
    lsr a
    sta MMC1_PRG
    lsr a
    sta MMC1_PRG
    jmp ORG_MENU
.endif


.ifdef ORG_MENU
    .byt $4d, $45, $4e, $55; "MENU"
    .org ORG_MENU
.endif
reset:

.ifndef ORG_PRESET
    sei
:   inc :- ; сброс маппера
.endif

    ; настраиваем маппер
    ; C=0 switch 8 KB
    ; PP=3 fix last bank $C000
    ; MM=0 one-screen, lower bank
    ;     CPPMM
    lda #%11100
    sta MMC1_CTRL
    lsr a
    sta MMC1_CTRL
    lsr a
    sta MMC1_CTRL
    lsr a
    sta MMC1_CTRL
    lsr a
    sta MMC1_CTRL

    ; переключаем на chr с текстом
    lda #NBANK_FONT & %11111
    sta MMC1_CHR0
    lsr a
    sta MMC1_CHR0
    lsr a
    sta MMC1_CHR0
    lsr a
    sta MMC1_CHR0
    lsr a
    sta MMC1_CHR0

    lda #$ff
    tax
    txs ; указатель стека

	inx ; ldx #0
	stx PPU_CTRL		; запрет NMI
	stx PPU_MASK		; отключение спрайтов и фона
    stx APU_DMC_CTRL    ; отключение DMC IRQ


    ; ждем 2 vblank
    bit PPU_STATUS
:   bit PPU_STATUS
    bpl :-
:   bit PPU_STATUS
    bpl :-


    ; перемещаем все спрайты x=255,y=255
    ;ldx #0
	;lda #$ff
:	sta OAM_RAM, x
	inx
	bne :-
    ; настраиваем спрайт курсора
    sta OAM_RAM+0 ; у
    lda #ARROW_SIGN
    sta OAM_RAM+1 ; номер спрайта
    lda #%00010000 | 2 ; номер палитры 0-3
    sta OAM_RAM+2 ; атрибут
    lda #(8*2)
    sta OAM_RAM+3 ; x

    ; загрузка палитры
    ldx #>$3F00
    stx PPU_ADDR
    ldx #<$3F00
    stx PPU_ADDR

    ;фона
	ldx #0
:	lda palette,x
	sta PPU_DATA
	inx
	cpx #16
	bcc :-

    ; спайтов, та же самая палитра
    ldx #0
:	lda palette,x
	sta PPU_DATA
	inx
	cpx #16
	bcc :-
    

    ; очистка первой экранной страницы
    ldx #>$2000
    stx PPU_ADDR
    ldx #<$2000
    stx PPU_ADDR
	lda #' ' ; пустой тайл
	ldx #32*30/4	; 32*30/4=960/4=240
:	sta PPU_DATA
	sta PPU_DATA
	sta PPU_DATA
	sta PPU_DATA
	dex
	bne :-

    ; палитра для первой строки, PPU_ADDR уже установлен
	ldx #8
	lda #%00000000	; палитра 0
:	sta PPU_DATA
	dex
	bne :-

    ; палитра для второй строки, PPU_ADDR установлен
	ldx #8
	lda #%10100101	; палитра 1
:	sta PPU_DATA
	dex
	bne :-

    ; палитра для все остальных строк, PPU_ADDR установлен
	ldx #(64-8-8)
	lda #%10101010
:	sta PPU_DATA
	dex
	bne :-

    ; загружаем текст меню в 1 страницу
    ldx #>$2000
    stx PPU_ADDR
    ldx #<$2000
    stx PPU_ADDR

    ; печатаем текст
    ;ldx #0 ; #<$2000 == #0

    ldy text_menu, x ; количество пробелов
@print_line:
    lda #' '
:   sta PPU_DATA
    dey
    bne :-

    inx
    ldy text_menu, x ; количество символов
:   inx
    lda text_menu, x ; символ
    sta PPU_DATA
    dey
    bne :-

    inx
    ldy text_menu, x ; количество пробелов
    bne @print_line ; пробелов 0 - конец


    ; настройка PPU
	lda #BG_0|SPR_0|NT_0|VRAM_RIGHT
	sta PPU_CTRL

	; включение спрайтов и бекграунда
	lda #BG_ON|SPR_ON|HIDE_BG_LHS|HIDE_SPR_LHS
	sta PPU_MASK

    ldy #0 ; выбранный пункт
mainloop:
    
    ; чтение джойстика
    lda #$01
    sta JOYPAD1
    sta joy1
    lsr a        ; A=0
    sta JOYPAD1
:   lda JOYPAD1
    lsr a	    ; bit0 -> Carry
    bcs :+ ; чтение 3 джойстика
    lsr a
:   rol joy1  ; Carry -> bit0; bit 7 -> Carry
    bcc :--

    ; фильтруем только нажатия
    lda joy1
    tax
    eor joy1prv
    and joy1
    stx joy1prv

    ; двигаем курсор
    ;bit:   	 7     6     5     4     3     2     1     0
    ;button:	 A     B  Select Start  Up   Down  Left  Right
    ror a ; 0bit Right
    ror a ; 1bit Left
    ror a ; 2bit Down
    bcc :+
    iny
:   ror a ; 3bit Up
    bcc :+
    dey
:   ror a ; 4bit Start
    bcs launch ; запускаем игру

    tya
    and #%11 ; ограничиваем пунткы 0-3 (1-4)
    tay

    clc
    adc #$03 ; начинается с 7 строки экрана
    asl a ; a = a*16
    asl a
    asl a
    asl a
    ;clc
    adc #$05 ; курсор по центру строки

:   bit PPU_STATUS
    bpl :-

    sta OAM_RAM+0 ; позиция курсора по у
	lda #>OAM_RAM ; вызов DMA
	sta OAM_DMA

    jmp mainloop


launch:; переключаем игру, в Y индекс банка из banktable

	; тушим экран, выключение спрайтов и бекграунда
	lda #BG_OFF|SPR_OFF|HIDE_BG_LHS|HIDE_SPR_LHS
	sta PPU_MASK

    ; копируем лаунчер в озу
    ldx #(launcher_end - launcher); количество байт в лаунчере
:   dex
    lda launcher, x
    sta codehere, x
    txa
    bne :-

    ; 
    ; после переключения маппера на шине данных должны стоять 6-5-4 биты для 161 защелки
    ; микросхемные нормально переключаются и без этого трюка,а для капельных обязательно
    ; используются бесполезные команды портящие аккумулятор и неофициальные NOP
    ;
    ;      7 654 3210
    ; $0A  0 000 1010    ASL A
    ; $1A  0 001 1010    NOP
    ; $2A  0 010 1010    ROL A
    ; $3A  0 011 1010    NOP
    ; $4A  0 100 1010    LSR A
    ; $5A  0 101 1010    NOP
    ; $6A  0 110 1010    ROR A
    ; $7A  0 111 1010    NOP
    lda #$0A
    ora banktable, y
    sta launcher_fix - launcher + codehere
    sta launcher_fix - launcher + codehere + 1
    sta launcher_fix - launcher + codehere + 2
    sta launcher_fix - launcher + codehere + 3

    ;
    ; переключаем мирроринг 00->01
    ;     CPPMM
    lda #%11101
    sta MMC1_CTRL
    lsr a
    sta MMC1_CTRL
    lsr a
    sta MMC1_CTRL
    lsr a
    sta MMC1_CTRL
    lsr a
    ora banktable,y

    ldx banktable,y

    jmp codehere ; переход в озу


.ifdef ORG_MENU2; деление кода на две части, если не влезает
    .byt $4d, $45, $4e, $55, $32; "MENU"
    .org ORG_MENU2
.endif


launcher:
    sta MMC1_CTRL
launcher_fix:
    nop
    nop
    nop
    nop

    txa
    and #%110 << 4; проверка на нулевую игру
    bne :+
    jmp RESET_OLD
:
    jmp ($fffc)
launcher_end:

banktable:
    ; D6 - A18 PRG+CHR, A14 WRAM
    ; D5 - A17 PRG+CHR (128k)
    ; D4 - A13 WRAM
    ;     D654                 128k                     256k
    .byt %000 << 4; 128k bank0 + WRAM bank0 | 256k bank0 + WRAM bank0
    ;.byt %001 << 4; 128k bank0 + WRAM bank1 | 256k bank0 + WRAM bank1
    .byt %010 << 4; 128k bank1 + WRAM bank0 | 256k bank0 + WRAM bank0
    ;.byt %011 << 4; 128k bank1 + WRAM bank1 | 256k bank0 + WRAM bank1
    .byt %100 << 4; 128k bank2 + WRAM bank2 | 256k bank1 + WRAM bank3
    ;.byt %101 << 4; 128k bank2 + WRAM bank3 | 256k bank1 + WRAM bank4
    .byt %110 << 4; 128k bank3 + WRAM bank2 | 256k bank1 + WRAM bank3
    ;.byt %111 << 4; 128k bank3 + WRAM bank3 | 256k bank1 + WRAM bank4

    

palette:
    ; палитра
	.byt $0f, $19, $29, $39; зеленый
	.byt $0f, $18, $28, $38; оранжевый
	.byt $0f, $11, $21, $31; синий
	.byt $0f, $15, $25, $35; розовый


text_menu:
    ; количество пробелов, длинна строки, строка
    .include "menu-text.asm"


.segment "CHR"
	.incbin "Darkwing Duck (U) [!].rus.nes.chr"

; vim:ft=a65:
